import TEMPLATE from './template'
import { ACTION_ALL, CLASS_HIDDEN, CLASS_INVISIBLE, CLASS_MOVE, DATA_ACTION, NAMESPACE } from './constants'
import { addClass, setData } from './utilities'

export default {
  methods: {
    builder() {
      const { element, $props } = this

      // Create cropper elements
      const container = element.parentNode
      const template = document.createElement('div')

      template.innerHTML = TEMPLATE

      const cropper = template.querySelector(`.${NAMESPACE}-container`)
      const canvas = cropper.querySelector(`.${NAMESPACE}-canvas`)
      const dragBox = cropper.querySelector(`.${NAMESPACE}-drag-box`)
      const cropBox = cropper.querySelector(`.${NAMESPACE}-crop-box`)
      const face = cropBox.querySelector(`.${NAMESPACE}-face`)

      this.container = container
      this.cropper = cropper
      this.canvas = canvas
      this.dragBox = dragBox
      this.cropBox = cropBox
      this.viewBox = cropper.querySelector(`.${NAMESPACE}-view-box`)
      this.face = face

      // Hide the original image
      addClass(element, CLASS_HIDDEN)

      addClass(cropBox, CLASS_HIDDEN)

      if (!$props.guides) {
        addClass(cropBox.getElementsByClassName(`${NAMESPACE}-dashed`), CLASS_HIDDEN)
      }

      if (!$props.center) {
        addClass(cropBox.getElementsByClassName(`${NAMESPACE}-center`), CLASS_HIDDEN)
      }

      if ($props.background) {
        addClass(cropper, `${NAMESPACE}-bg`)
      }

      if (!$props.highlight) {
        addClass(face, CLASS_INVISIBLE)
      }

      if ($props.cropBoxMovable) {
        addClass(face, CLASS_MOVE)
        setData(face, DATA_ACTION, ACTION_ALL)
      }

      if (!$props.cropBoxResizable) {
        addClass(cropBox.getElementsByClassName(`${NAMESPACE}-line`), CLASS_HIDDEN)
        addClass(cropBox.getElementsByClassName(`${NAMESPACE}-point`), CLASS_HIDDEN)
      }

      // Inserts the cropper after to the current image
      container.insertBefore(cropper, element.nextSibling)
      this.initContainer()
      this.ready = true
      this.onReady()
      this.setDragMode()
    }
  }
}
