import { assign, addClass, removeClass } from './utilities'
import { CLASS_HIDDEN, CLASS_INVISIBLE, CLASS_MODAL, NAMESPACE } from './constants'
export default {
  watch: {
    dragMode() {
      this.setDragMode()
    },
    viewMode() {
      this.imageData = assign({}, this.initialImageData)
      this.initCanvas()
      this.reset()
    },
    src(val) {
      const { viewBox, canvas } = this
      viewBox.removeChild(viewBox.getElementsByTagName('img')[0])
      canvas.removeChild(canvas.getElementsByTagName('img')[0])
      if (val) {
        this.loadImage(val)
      } else {
        this.clear()
        this.unbind()
      }
    },
    modal(val) {
      if (val) {
        addClass(this.dragBox, CLASS_MODAL)
      } else {
        removeClass(this.dragBox, CLASS_MODAL)
      }
    },
    guides(val) {
      if (val) {
        addClass(this.cropBox.getElementsByClassName(`${NAMESPACE}-dashed`), CLASS_HIDDEN)
      } else {
        removeClass(this.cropBox.getElementsByClassName(`${NAMESPACE}-dashed`), CLASS_HIDDEN)
      }
    },
    center(val) {
      if (val) {
        addClass(this.cropBox.getElementsByClassName(`${NAMESPACE}-center`), CLASS_HIDDEN)
      } else {
        removeClass(this.cropBox.getElementsByClassName(`${NAMESPACE}-center`), CLASS_HIDDEN)
      }
    },
    highlight(val) {
      if (val) {
        addClass(this.face, CLASS_INVISIBLE)
      } else {
        removeClass(this.face, CLASS_INVISIBLE)
      }
    },
    background(val) {
      if (val) {
        addClass(this.cropper, `${NAMESPACE}-bg`)
      } else {
        removeClass(this.cropper, `${NAMESPACE}-bg`)
      }
    }
  }
}
